// Code generated by informer-gen. DO NOT EDIT.

package v1

import (
	"context"
	time "time"

	apiserverv1 "github.com/openshift/api/apiserver/v1"
	versioned "github.com/openshift/client-go/apiserver/clientset/versioned"
	internalinterfaces "github.com/openshift/client-go/apiserver/informers/externalversions/internalinterfaces"
	v1 "github.com/openshift/client-go/apiserver/listers/apiserver/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// DeprecatedAPIRequestInformer provides access to a shared informer and lister for
// DeprecatedAPIRequests.
type DeprecatedAPIRequestInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1.DeprecatedAPIRequestLister
}

type deprecatedAPIRequestInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
}

// NewDeprecatedAPIRequestInformer constructs a new informer for DeprecatedAPIRequest type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewDeprecatedAPIRequestInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredDeprecatedAPIRequestInformer(client, resyncPeriod, indexers, nil)
}

// NewFilteredDeprecatedAPIRequestInformer constructs a new informer for DeprecatedAPIRequest type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredDeprecatedAPIRequestInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options metav1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.ApiserverV1().DeprecatedAPIRequests().List(context.TODO(), options)
			},
			WatchFunc: func(options metav1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.ApiserverV1().DeprecatedAPIRequests().Watch(context.TODO(), options)
			},
		},
		&apiserverv1.DeprecatedAPIRequest{},
		resyncPeriod,
		indexers,
	)
}

func (f *deprecatedAPIRequestInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredDeprecatedAPIRequestInformer(client, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *deprecatedAPIRequestInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&apiserverv1.DeprecatedAPIRequest{}, f.defaultInformer)
}

func (f *deprecatedAPIRequestInformer) Lister() v1.DeprecatedAPIRequestLister {
	return v1.NewDeprecatedAPIRequestLister(f.Informer().GetIndexer())
}
